=== modified file 'bzrlib/annotate.py'
--- bzrlib/annotate.py	2011-12-19 13:23:58 +0000
+++ bzrlib/annotate.py	2012-06-26 12:14:56 +0000
@@ -47,32 +47,6 @@
     CURRENT_REVISION,
     Revision,
     )
-from bzrlib.symbol_versioning import (
-    deprecated_function,
-    deprecated_in,
-    )
-
-
-@deprecated_function(deprecated_in((2, 4, 0)))
-def annotate_file(branch, rev_id, file_id, verbose=False, full=False,
-                  to_file=None, show_ids=False):
-    """Annotate file_id at revision rev_id in branch.
-
-    The branch should already be read_locked() when annotate_file is called.
-
-    :param branch: The branch to look for revision numbers and history from.
-    :param rev_id: The revision id to annotate.
-    :param file_id: The file_id to annotate.
-    :param verbose: Show all details rather than truncating to ensure
-        reasonable text width.
-    :param full: XXXX Not sure what this does.
-    :param to_file: The file to output the annotation to; if None stdout is
-        used.
-    :param show_ids: Show revision ids in the annotation output.
-    """
-    tree = branch.repository.revision_tree(rev_id)
-    annotate_file_tree(tree, file_id, to_file, verbose=verbose,
-        full=full, show_ids=show_ids, branch=branch)
 
 
 def annotate_file_tree(tree, file_id, to_file, verbose=False, full=False,

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2012-06-18 11:43:07 +0000
+++ bzrlib/branch.py	2012-06-26 15:33:56 +0000
@@ -1034,18 +1034,6 @@
     def _read_last_revision_info(self):
         raise NotImplementedError(self._read_last_revision_info)
 
-    @deprecated_method(deprecated_in((2, 4, 0)))
-    def import_last_revision_info(self, source_repo, revno, revid):
-        """Set the last revision info, importing from another repo if necessary.
-
-        :param source_repo: Source repository to optionally fetch from
-        :param revno: Revision number of the new tip
-        :param revid: Revision id of the new tip
-        """
-        if not self.repository.has_same_location(source_repo):
-            self.repository.fetch(source_repo, revision_id=revid)
-        self.set_last_revision_info(revno, revid)
-
     def import_last_revision_info_and_tags(self, source, revno, revid,
                                            lossy=False):
         """Set the last revision info, importing from another repo if necessary.
@@ -1694,11 +1682,6 @@
         """True if this format supports leaving locks in place."""
         return False # by default
 
-    @classmethod
-    @deprecated_method(deprecated_in((2, 4, 0)))
-    def unregister_format(klass, format):
-        format_registry.remove(format)
-
     def __str__(self):
         return self.get_format_description().rstrip()
 

=== modified file 'bzrlib/remote.py'
--- bzrlib/remote.py	2012-06-26 12:30:00 +0000
+++ bzrlib/remote.py	2012-06-28 16:17:34 +0000
@@ -2702,11 +2702,6 @@
     def supports_rich_root(self):
         return self._format.rich_root_data
 
-    @symbol_versioning.deprecated_method(symbol_versioning.deprecated_in((2, 4, 0)))
-    def iter_reverse_revision_history(self, revision_id):
-        self._ensure_real()
-        return self._real_repository.iter_reverse_revision_history(revision_id)
-
     @property
     def _serializer(self):
         return self._format._serializer

=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2012-06-26 12:30:00 +0000
+++ bzrlib/repository.py	2012-06-28 16:17:34 +0000
@@ -981,17 +981,6 @@
             raise AssertionError('_iter_for_revno returned too much history')
         return (True, partial_history[-1])
 
-    @symbol_versioning.deprecated_method(symbol_versioning.deprecated_in((2, 4, 0)))
-    def iter_reverse_revision_history(self, revision_id):
-        """Iterate backwards through revision ids in the lefthand history
-
-        :param revision_id: The revision id to start with.  All its lefthand
-            ancestors will be traversed.
-        """
-        graph = self.get_graph()
-        stop_revisions = (None, _mod_revision.NULL_REVISION)
-        return graph.iter_lefthand_ancestry(revision_id, stop_revisions)
-
     def is_shared(self):
         """Return True if this repository is flagged as a shared repository."""
         raise NotImplementedError(self.is_shared)
@@ -1398,22 +1387,6 @@
     def __ne__(self, other):
         return not self == other
 
-    @classmethod
-    @symbol_versioning.deprecated_method(symbol_versioning.deprecated_in((2, 4, 0)))
-    def register_format(klass, format):
-        format_registry.register(format)
-
-    @classmethod
-    @symbol_versioning.deprecated_method(symbol_versioning.deprecated_in((2, 4, 0)))
-    def unregister_format(klass, format):
-        format_registry.remove(format)
-
-    @classmethod
-    @symbol_versioning.deprecated_method(symbol_versioning.deprecated_in((2, 4, 0)))
-    def get_default_format(klass):
-        """Return the current default format."""
-        return format_registry.get_default()
-
     def get_format_description(self):
         """Return the short description for this format."""
         raise NotImplementedError(self.get_format_description)

=== modified file 'bzrlib/tests/per_branch/test_last_revision_info.py'
--- bzrlib/tests/per_branch/test_last_revision_info.py	2011-04-12 00:44:43 +0000
+++ bzrlib/tests/per_branch/test_last_revision_info.py	2012-06-26 12:26:45 +0000
@@ -17,7 +17,6 @@
 """Tests for branch.last_revision_info."""
 
 from bzrlib.revision import NULL_REVISION
-from bzrlib.symbol_versioning import deprecated_in
 from bzrlib.tests import TestCaseWithTransport
 
 
@@ -35,27 +34,6 @@
         revid = tree.commit('2st post', allow_pointless=True)
         self.assertEqual((2, revid), tree.branch.last_revision_info())
 
-    def test_import_deprecated(self):
-        # importing and setting last revision
-        tree1 = self.make_branch_and_tree('branch1')
-        tree1.commit('1st post')
-        revid = tree1.commit('2st post', allow_pointless=True)
-        branch2 = self.make_branch('branch2')
-        self.applyDeprecated(deprecated_in((2, 4, 0)),
-            branch2.import_last_revision_info, tree1.branch.repository, 2, revid)
-        self.assertEqual((2, revid), branch2.last_revision_info())
-        self.assertTrue(branch2.repository.has_revision(revid))
-
-    def test_same_repo_deprecated(self):
-        # importing and setting last revision within the same repo
-        tree = self.make_branch_and_tree('branch1')
-        tree.commit('1st post')
-        revid = tree.commit('2st post', allow_pointless=True)
-        tree.branch.set_last_revision_info(0, NULL_REVISION)
-        self.applyDeprecated(deprecated_in((2, 4, 0)),
-            tree.branch.import_last_revision_info, tree.branch.repository, 2, revid)
-        self.assertEqual((2, revid), tree.branch.last_revision_info())
-
     def test_import(self):
         # importing and setting last revision
         tree1 = self.make_branch_and_tree('branch1')

=== modified file 'bzrlib/tests/per_repository/__init__.py'
--- bzrlib/tests/per_repository/__init__.py	2012-02-23 23:41:51 +0000
+++ bzrlib/tests/per_repository/__init__.py	2012-06-26 12:33:14 +0000
@@ -120,7 +120,6 @@
         'test_get_parent_map',
         'test_has_same_location',
         'test_has_revisions',
-        'test_iter_reverse_revision_history',
         'test_locking',
         'test_pack',
         'test_reconcile',

=== removed file 'bzrlib/tests/per_repository/test_iter_reverse_revision_history.py'
--- bzrlib/tests/per_repository/test_iter_reverse_revision_history.py	2011-09-09 12:17:12 +0000
+++ bzrlib/tests/per_repository/test_iter_reverse_revision_history.py	1970-01-01 00:00:00 +0000
@@ -1,173 +0,0 @@
-# Copyright (C) 2007 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Test iter_reverse_revision_history."""
-
-from bzrlib import (
-    errors,
-    tests,
-    )
-from bzrlib.symbol_versioning import deprecated_in
-from bzrlib.tests.per_repository import TestCaseWithRepository
-
-
-class TestIterReverseRevisionHistory(TestCaseWithRepository):
-
-    def create_linear_history(self):
-        tree = self.make_branch_and_memory_tree('tree')
-        tree.lock_write()
-        try:
-            tree.add('')
-            tree.commit('1', rev_id='rev1')
-            tree.commit('2', rev_id='rev2')
-            tree.commit('3', rev_id='rev3')
-            tree.commit('4', rev_id='rev4')
-        finally:
-            tree.unlock()
-        return tree
-
-    def create_linear_history_with_utf8(self):
-        tree = self.make_branch_and_memory_tree('tree')
-        tree.lock_write()
-        try:
-            tree.add('') # needed for MemoryTree
-            try:
-                tree.commit(u'F\xb5', rev_id=u'rev-\xb5'.encode('utf8'))
-            except errors.NonAsciiRevisionId:
-                raise tests.TestSkipped("%s doesn't support non-ascii"
-                                        " revision ids."
-                                        % self.repository_format)
-            tree.commit(u'B\xe5r', rev_id=u'rev-\xe5'.encode('utf8'))
-        finally:
-            tree.unlock()
-        return tree
-
-    def create_merged_history(self):
-        # TODO: jam 20070216 MutableTree doesn't yet have the pull() or
-        #       merge_from_branch() apis. So we have to use real trees for
-        #       this.
-        tree1 = self.make_branch_and_tree('tree1')
-        tree2 = self.make_branch_and_tree('tree2')
-        tree1.lock_write()
-        tree2.lock_write()
-        try:
-            tree1.add('')
-            tree1.commit('rev-1-1', rev_id='rev-1-1')
-            tree2.pull(tree1.branch)
-            tree2.commit('rev-2-2', rev_id='rev-2-2')
-            tree2.commit('rev-2-3', rev_id='rev-2-3')
-            tree2.commit('rev-2-4', rev_id='rev-2-4')
-
-            tree1.commit('rev-1-2', rev_id='rev-1-2')
-            tree1.flush() # workaround merge using _write_inventory
-            tree1.merge_from_branch(tree2.branch)
-            tree1.commit('rev-1-3', rev_id='rev-1-3')
-
-            tree2.commit('rev-2-5', rev_id='rev-2-5')
-            # Make sure both repositories have all revisions
-            tree1.branch.repository.fetch(tree2.branch.repository,
-                                          revision_id='rev-2-5')
-            tree2.branch.repository.fetch(tree1.branch.repository,
-                                          revision_id='rev-1-3')
-        finally:
-            tree2.unlock()
-            tree1.unlock()
-        return tree1, tree2
-
-    def test_is_generator(self):
-        tree = self.create_linear_history()
-        repo = tree.branch.repository
-        repo.lock_read()
-        self.addCleanup(repo.unlock)
-        rev_history = self.applyDeprecated(deprecated_in((2, 4, 0)),
-            repo.iter_reverse_revision_history, 'rev4')
-        self.assertEqual('rev4', rev_history.next())
-        self.assertEqual('rev3', rev_history.next())
-        self.assertEqual('rev2', rev_history.next())
-        self.assertEqual('rev1', rev_history.next())
-        self.assertRaises(StopIteration, rev_history.next)
-
-    def assertRevHistoryList(self, expected, repo, revision_id):
-        """Assert the return values of iter_reverse_revision_history."""
-        repo.lock_read()
-        try:
-            actual = list(self.applyDeprecated(deprecated_in((2, 4, 0)),
-                repo.iter_reverse_revision_history, revision_id))
-        finally:
-            repo.unlock()
-        self.assertEqual(expected, actual)
-
-    def test_linear_history(self):
-        tree = self.create_linear_history()
-        repo = tree.branch.repository
-
-        self.assertRevHistoryList(['rev4', 'rev3', 'rev2', 'rev1'],
-                                  repo, 'rev4')
-
-    def test_partial_history(self):
-        tree = self.create_linear_history()
-        repo = tree.branch.repository
-
-        self.assertRevHistoryList(['rev3', 'rev2', 'rev1'], repo, 'rev3')
-
-    def test_revision_ids_are_utf8(self):
-        tree = self.create_linear_history_with_utf8()
-        repo = tree.branch.repository
-        self.assertRevHistoryList(['rev-\xc3\xa5', 'rev-\xc2\xb5'],
-                                  repo, 'rev-\xc3\xa5')
-
-    def test_merged_history(self):
-        tree1, tree2 = self.create_merged_history()
-        repo = tree1.branch.repository
-
-        self.assertRevHistoryList(['rev-1-1'],
-                                  repo, 'rev-1-1')
-        self.assertRevHistoryList(['rev-1-2', 'rev-1-1'],
-                                  repo, 'rev-1-2')
-        self.assertRevHistoryList(['rev-1-3', 'rev-1-2', 'rev-1-1'],
-                                  repo, 'rev-1-3')
-        self.assertRevHistoryList(['rev-2-2', 'rev-1-1'],
-                                  repo, 'rev-2-2')
-        self.assertRevHistoryList(['rev-2-3', 'rev-2-2', 'rev-1-1'],
-                                  repo, 'rev-2-3')
-        self.assertRevHistoryList(['rev-2-4', 'rev-2-3', 'rev-2-2', 'rev-1-1'],
-                                  repo, 'rev-2-4')
-        self.assertRevHistoryList(['rev-2-5', 'rev-2-4', 'rev-2-3', 'rev-2-2',
-                                   'rev-1-1'], repo, 'rev-2-5')
-
-    def test_ghost(self):
-        tree = self.make_branch_and_memory_tree('tree')
-        if not tree.branch.repository._format.supports_ghosts:
-            raise tests.TestNotApplicable(
-                "repository format does not support ghosts")
-        tree.lock_write()
-        try:
-            tree.add('')
-            tree.set_parent_ids(['spooky'], allow_leftmost_as_ghost=True)
-            tree.commit('1', rev_id='rev1')
-            tree.commit('2', rev_id='rev2')
-        finally:
-            tree.unlock()
-        iter = self.applyDeprecated(deprecated_in((2, 4, 0)),
-            tree.branch.repository.iter_reverse_revision_history, 'rev2')
-        tree.branch.repository.lock_read()
-        try:
-            self.assertEquals('rev2', iter.next())
-            self.assertEquals('rev1', iter.next())
-            self.assertRaises(errors.RevisionNotPresent, iter.next)
-        finally:
-            tree.branch.repository.unlock()
-

=== modified file 'bzrlib/tests/test_annotate.py'
--- bzrlib/tests/test_annotate.py	2011-05-03 13:53:46 +0000
+++ bzrlib/tests/test_annotate.py	2012-06-26 12:14:56 +0000
@@ -302,19 +302,6 @@
                                   '1.1.1 barry@f | third\n',
                                   builder.get_branch(), 'a-id', 'rev-3')
 
-    def test_annotate_file(self):
-        builder = self.create_merged_trees()
-
-        to_file = StringIO()
-        self.applyDeprecated(symbol_versioning.deprecated_in((2, 4, 0)),
-            annotate.annotate_file, builder.get_branch(),
-                'rev-3', 'a-id', to_file=to_file)
-
-        self.assertAnnotateEqualDiff('1     joe@foo | first\n'
-                                     '2     joe@foo | second\n'
-                                     '1.1.1 barry@f | third\n',
-                                     to_file.getvalue())
-
     def test_annotate_limits_dotted_revnos(self):
         """Annotate should limit dotted revnos to a depth of 12"""
         builder = self.create_deeply_merged_trees()

=== modified file 'bzrlib/tests/test_repository.py'
--- bzrlib/tests/test_repository.py	2012-02-23 19:45:15 +0000
+++ bzrlib/tests/test_repository.py	2012-06-26 12:58:22 +0000
@@ -178,25 +178,6 @@
         repository.RepositoryFormatMetaDir.register_feature("name")
         found_format.check_support_status(True)
 
-    def test_register_unregister_format(self):
-        # Test deprecated format registration functions
-        format = SampleRepositoryFormat()
-        # make a control dir
-        dir = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
-        # make a repo
-        format.initialize(dir)
-        # register a format for it.
-        self.applyDeprecated(symbol_versioning.deprecated_in((2, 4, 0)),
-            repository.RepositoryFormat.register_format, format)
-        # which repository.Open will refuse (not supported)
-        self.assertRaises(UnsupportedFormatError, repository.Repository.open,
-            self.get_url())
-        # but open(unsupported) will work
-        self.assertEqual(format.open(dir), "opened repository.")
-        # unregister the format
-        self.applyDeprecated(symbol_versioning.deprecated_in((2, 4, 0)),
-            repository.RepositoryFormat.unregister_format, format)
-
 
 class TestRepositoryFormatRegistry(TestCase):
 

=== modified file 'doc/en/release-notes/bzr-2.6.txt'
--- doc/en/release-notes/bzr-2.6.txt	2012-06-26 12:30:00 +0000
+++ doc/en/release-notes/bzr-2.6.txt	2012-06-28 16:17:34 +0000
@@ -60,6 +60,17 @@
 
 * Remove deprecated Repository.get_ancestry(). (Jelmer Vernooij)
 
+* Remove deprecated Branch.import_last_revision(). (Jelmer Vernooij)
+
+* Remove deprecated Repository.iter_reverse_revision_history().
+  (Jelmer Vernooij)
+
+* Remove deprecated ``RepositoryFormat.register_format``.
+  (Jelmer Vernooij)
+
+* The previously deprecated ``bzrlib.annotate.annotate_file`` function
+  has been removed. (Jelmer Vernooij)
+
 Internals
 *********
 

